Loading...
Searching...
No Matches
L4::Irq_eoi Class Reference

Interface for sending an unmask message to an object. More...

`#include <irq>`

Inheritance diagram for L4::Irq_eoi:
Collaboration diagram for L4::Irq_eoi:

## Public Member Functions

l4_msgtag_t | unmask (unsigned irqnum, l4_umword_t *label=0, l4_timeout_t to=L4_IPC_NEVER, l4_utcb_t *utcb=l4_utcb()) noexcept
| Unmask the given interrupt line.

## Detailed Description

Interface for sending an unmask message to an object.

The object is usually an ICU or an IRQ.

When the kernel receives an IRQ, it masks the interrupt line at the interrupt controller and immediately acknowledges the interrupt. This interface is used to let the kernel know that userspace has dealt with the IRQ. The kernel will unmask the interrupt line and further IRQs can then be delivered.

See also
  L4::Icu, L4::Irq

Definition at line 37 of file irq.

## Member Function Documentation

## unmask()

l4_msgtag_t L4::Irq_eoi::unmask | ( | unsigned | irqnum,
|  | l4_umword_t * | label = 0,
|  | l4_timeout_t | to = L4_IPC_NEVER,
|  | l4_utcb_t * | utcb = l4_utcb() )

inlinenoexcept

Unmask the given interrupt line.

When the object is an IRQ, the given interrupt line is ignored and instead the line which the IRQ is bound to (if any) is unmasked.

Its counterpart for explicitly masking an interrupt line is L4::Icu::mask().

Parameters

  | irqnum | The interrupt line that shall be unmasked. Ignored if the object is an IRQ.
  [out] | label | If NULL, this is a send-only unmask. If not NULL, this operation enters an open wait and the protected label shall be received here.
  | to | The timeout-pair (send and receive) that shall be used for this operation. The receive timeout is used with a non-NULL label only.
  | utcb | UTCB to be used for this operation, shall be the UTCB of the calling thread. See l4_utcb.

Returns
  Syscall return tag. If label is NULL, this function performs an IPC send-only operation and there is no return value except L4_MSGTAG_ERROR indicating success or failure of the send operation. In this case use l4_ipc_error() to check for errors and do not use l4_error().

Definition at line 64 of file irq.

References L4::Kobject::cap(), and L4_IPC_NEVER.

Here is the call graph for this function:

The documentation for this class was generated from the following file:

- l4/sys/irq